{
    *******************************************************
    * "De Delphi  C# avec BDS 2006"  ISBN 2-212-11768-X  *
    *******************************************************
    *                                                     *
    * Code source correspond aux exemples traits dans l' *
    * ouvrage.                                            *
    *                                                     *
    * Environment : Borland Developer Studio 2006         *
    * Test sur la version Architecte Franaise patch 1   *
    *                                                     *
    * Copyright   : Olivier Dahan                         *
    *                                                     *
    * Aucune copie, distribution, publication sans l'     *
    * accord exprs de l'auteur.                          *
    * Le prsent code source est fourni "tel quel"       *
    * titre d'illustration des propos techniques du livre *
    * Aucune garantie de fonctionnement ou d'adaptation   *
    * n'est fournie, aucune maintenance corrective ou     *
    * volutive ne sera fournie sur le prsent code.      *
    * Vous utilisez ce code sous votre seule responsabi-  *
    * lit et  vos risques et prils. L'auteur ne serait *
    * tre tenu pour responsable d'ventuelles pertes de  *
    * donnes ou de jouissance qui pourraient rsulter de *
    * l'utilisation du prsent code.                      *
    *                                                     *
    * Contact          : BDSLivre@e-naxos.com             *
    * Site de l'auteur : http://www.e-naxos.com           *
    *******************************************************

}



unit MainForm;

interface

uses
  System.Drawing, System.Collections, System.ComponentModel,
  System.Windows.Forms, System.Data, Borland.Data.Provider,
  Borland.Vcl.SysUtils,Borland.Vcl.StrUtils, Borland.Data.Common;

type
  TWinForm2 = class(System.Windows.Forms.Form)
  {$REGION 'Code manag du concepteur'}
  strict private
    /// <summary>
    /// Variable concepteur obligatoire.
    /// </summary>
    Components: System.ComponentModel.Container;
    BdpConnection1: Borland.Data.Provider.BdpConnection;
    BdpCommand1: Borland.Data.Provider.BdpCommand;
    TextBox1: System.Windows.Forms.TextBox;
    TextBox2: System.Windows.Forms.TextBox;
    TextBox3: System.Windows.Forms.TextBox;
    txtmemo: System.Windows.Forms.TextBox;
    Button1: System.Windows.Forms.Button;
    RadioButton1: System.Windows.Forms.RadioButton;
    RadioButton2: System.Windows.Forms.RadioButton;
    RadioButton3: System.Windows.Forms.RadioButton;
    TextBox4: System.Windows.Forms.TextBox;
    Label1: System.Windows.Forms.Label;
    Label2: System.Windows.Forms.Label;
    Label3: System.Windows.Forms.Label;
    /// <summary>
    /// Mthode obligatoire pour la gestion du concepteur - Ne modifiez pas
    /// le contenu de cette mthode avec l'diteur de code.
    /// </summary>
    procedure InitializeComponent;
    procedure Button1_Click(sender: System.Object; e: System.EventArgs);
  {$ENDREGION}
  strict protected
    /// <summary>
    /// Nettoyage des ressources utilises.
    /// </summary>
    procedure Dispose(Disposing: Boolean); override;
  private
    { Dclarations prives }
  public
    constructor Create;
  end;

  [assembly: RuntimeRequiredAttribute(TypeOf(TWinForm2))]

implementation

{$AUTOBOX ON}

{$REGION 'Code gnr par le concepteur de Windows Form'}
/// <summary>
/// Mthode obligatoire pour la gestion du concepteur - Ne modifiez pas
/// le contenu de cette mthode avec l'diteur de code.
/// </summary>
procedure TWinForm2.InitializeComponent;
begin
  Self.BdpConnection1 := Borland.Data.Provider.BdpConnection.Create;
  Self.BdpCommand1 := Borland.Data.Provider.BdpCommand.Create;
  Self.TextBox1 := System.Windows.Forms.TextBox.Create;
  Self.TextBox2 := System.Windows.Forms.TextBox.Create;
  Self.TextBox3 := System.Windows.Forms.TextBox.Create;
  Self.txtmemo := System.Windows.Forms.TextBox.Create;
  Self.Button1 := System.Windows.Forms.Button.Create;
  Self.RadioButton1 := System.Windows.Forms.RadioButton.Create;
  Self.RadioButton2 := System.Windows.Forms.RadioButton.Create;
  Self.RadioButton3 := System.Windows.Forms.RadioButton.Create;
  Self.TextBox4 := System.Windows.Forms.TextBox.Create;
  Self.Label1 := System.Windows.Forms.Label.Create;
  Self.Label2 := System.Windows.Forms.Label.Create;
  Self.Label3 := System.Windows.Forms.Label.Create;
  Self.SuspendLayout;
  // 
  // BdpConnection1
  // 
  Self.BdpConnection1.ConnectionOptions := 'waitonlocks=False;commitretain=F' +
  'alse;sqldialect=3;transaction isolation=ReadCommitted;servercharset=;role' +
  'name=';
  Self.BdpConnection1.ConnectionString := 'assembly=Borland.Data.Interbase, ' +
  'Version=2.5.0.0, Culture=neutral, PublicKeyToken=91d62ebb5b0d1b1b;vendorc' +
  'lient=gds32.dll;pooling=True;grow on demand=True;database=..\data\dbdemos' +
  '.gdb;username=sysdba;max pool size=100;password=masterkey;provider=Interb' +
  'ase';
  // 
  // BdpCommand1
  // 
  Self.BdpCommand1.CommandOptions := nil;
  Self.BdpCommand1.CommandText := nil;
  Self.BdpCommand1.CommandType := System.Data.CommandType.Text;
  Self.BdpCommand1.Connection := Self.BdpConnection1;
  Self.BdpCommand1.ParameterCount := (SmallInt(0));
  Self.BdpCommand1.SchemaName := nil;
  Self.BdpCommand1.Transaction := nil;
  Self.BdpCommand1.UpdatedRowSource := System.Data.UpdateRowSource.None;
  // 
  // TextBox1
  // 
  Self.TextBox1.BackColor := System.Drawing.Color.FromArgb((Byte(255)), (Byte(224)), 
      (Byte(192)));
  Self.TextBox1.BorderStyle := System.Windows.Forms.BorderStyle.FixedSingle;
  Self.TextBox1.Location := System.Drawing.Point.Create(16, 16);
  Self.TextBox1.Name := 'TextBox1';
  Self.TextBox1.ReadOnly := True;
  Self.TextBox1.Size := System.Drawing.Size.Create(462, 20);
  Self.TextBox1.TabIndex := 0;
  Self.TextBox1.Tag := '0';
  Self.TextBox1.Text := 'SELECT * FROM ANIMALS';
  // 
  // TextBox2
  // 
  Self.TextBox2.BackColor := System.Drawing.Color.FromArgb((Byte(255)), (Byte(224)), 
      (Byte(192)));
  Self.TextBox2.BorderStyle := System.Windows.Forms.BorderStyle.FixedSingle;
  Self.TextBox2.Location := System.Drawing.Point.Create(16, 45);
  Self.TextBox2.Name := 'TextBox2';
  Self.TextBox2.ReadOnly := True;
  Self.TextBox2.Size := System.Drawing.Size.Create(307, 20);
  Self.TextBox2.TabIndex := 1;
  Self.TextBox2.Tag := '1';
  Self.TextBox2.Text := 'UPDATE ANIMALS SET SIZ_ = ? WHERE Name = ''Boa''';
  // 
  // TextBox3
  // 
  Self.TextBox3.BackColor := System.Drawing.Color.FromArgb((Byte(255)), (Byte(224)), 
      (Byte(192)));
  Self.TextBox3.BorderStyle := System.Windows.Forms.BorderStyle.FixedSingle;
  Self.TextBox3.Location := System.Drawing.Point.Create(16, 77);
  Self.TextBox3.Name := 'TextBox3';
  Self.TextBox3.ReadOnly := True;
  Self.TextBox3.Size := System.Drawing.Size.Create(462, 20);
  Self.TextBox3.TabIndex := 2;
  Self.TextBox3.Tag := '2';
  Self.TextBox3.Text := 'SELECT MAX(WEIGHT) FROM ANIMALS';
  // 
  // txtmemo
  // 
  Self.txtmemo.BorderStyle := System.Windows.Forms.BorderStyle.FixedSingle;
  Self.txtmemo.Dock := System.Windows.Forms.DockStyle.Bottom;
  Self.txtmemo.Font := System.Drawing.Font.Create('Courier New', 8.25, System.Drawing.FontStyle.Regular, 
      System.Drawing.GraphicsUnit.Point, (Byte(0)));
  Self.txtmemo.Location := System.Drawing.Point.Create(0, 149);
  Self.txtmemo.Multiline := True;
  Self.txtmemo.Name := 'txtmemo';
  Self.txtmemo.ScrollBars := System.Windows.Forms.ScrollBars.Vertical;
  Self.txtmemo.Size := System.Drawing.Size.Create(596, 258);
  Self.txtmemo.TabIndex := 3;
  Self.txtmemo.Text := '';
  // 
  // Button1
  // 
  Self.Button1.BackColor := System.Drawing.Color.FromArgb((Byte(192)), (Byte(192)), 
      (Byte(255)));
  Self.Button1.FlatStyle := System.Windows.Forms.FlatStyle.Flat;
  Self.Button1.Font := System.Drawing.Font.Create('Microsoft Sans Serif', 8.25, 
      System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, (Byte(0)));
  Self.Button1.Location := System.Drawing.Point.Create(404, 107);
  Self.Button1.Name := 'Button1';
  Self.Button1.TabIndex := 4;
  Self.Button1.Text := 'Excuter!';
  Include(Self.Button1.Click, Self.Button1_Click);
  // 
  // RadioButton1
  // 
  Self.RadioButton1.CheckAlign := System.Drawing.ContentAlignment.MiddleCenter;
  Self.RadioButton1.Checked := True;
  Self.RadioButton1.Cursor := System.Windows.Forms.Cursors.Hand;
  Self.RadioButton1.FlatStyle := System.Windows.Forms.FlatStyle.Popup;
  Self.RadioButton1.Location := System.Drawing.Point.Create(486, 15);
  Self.RadioButton1.Name := 'RadioButton1';
  Self.RadioButton1.Size := System.Drawing.Size.Create(54, 24);
  Self.RadioButton1.TabIndex := 5;
  Self.RadioButton1.TabStop := True;
  Self.RadioButton1.Tag := '0';
  Self.RadioButton1.TextAlign := System.Drawing.ContentAlignment.TopLeft;
  // 
  // RadioButton2
  // 
  Self.RadioButton2.CheckAlign := System.Drawing.ContentAlignment.MiddleCenter;
  Self.RadioButton2.Cursor := System.Windows.Forms.Cursors.Hand;
  Self.RadioButton2.FlatStyle := System.Windows.Forms.FlatStyle.Popup;
  Self.RadioButton2.Location := System.Drawing.Point.Create(486, 45);
  Self.RadioButton2.Name := 'RadioButton2';
  Self.RadioButton2.Size := System.Drawing.Size.Create(54, 24);
  Self.RadioButton2.TabIndex := 6;
  Self.RadioButton2.Tag := '1';
  Self.RadioButton2.TextAlign := System.Drawing.ContentAlignment.TopLeft;
  // 
  // RadioButton3
  // 
  Self.RadioButton3.CheckAlign := System.Drawing.ContentAlignment.MiddleCenter;
  Self.RadioButton3.Cursor := System.Windows.Forms.Cursors.Hand;
  Self.RadioButton3.FlatStyle := System.Windows.Forms.FlatStyle.Popup;
  Self.RadioButton3.Location := System.Drawing.Point.Create(486, 75);
  Self.RadioButton3.Name := 'RadioButton3';
  Self.RadioButton3.Size := System.Drawing.Size.Create(54, 24);
  Self.RadioButton3.TabIndex := 7;
  Self.RadioButton3.Tag := '2';
  Self.RadioButton3.TextAlign := System.Drawing.ContentAlignment.TopLeft;
  // 
  // TextBox4
  // 
  Self.TextBox4.BorderStyle := System.Windows.Forms.BorderStyle.FixedSingle;
  Self.TextBox4.Location := System.Drawing.Point.Create(440, 47);
  Self.TextBox4.Name := 'TextBox4';
  Self.TextBox4.Size := System.Drawing.Size.Create(38, 20);
  Self.TextBox4.TabIndex := 8;
  Self.TextBox4.Text := '99';
  // 
  // Label1
  // 
  Self.Label1.Location := System.Drawing.Point.Create(368, 50);
  Self.Label1.Name := 'Label1';
  Self.Label1.Size := System.Drawing.Size.Create(66, 18);
  Self.Label1.TabIndex := 9;
  Self.Label1.Text := 'Paramtre :';
  // 
  // Label2
  // 
  Self.Label2.AutoSize := True;
  Self.Label2.FlatStyle := System.Windows.Forms.FlatStyle.Flat;
  Self.Label2.Location := System.Drawing.Point.Create(487, 2);
  Self.Label2.Name := 'Label2';
  Self.Label2.Size := System.Drawing.Size.Create(51, 16);
  Self.Label2.TabIndex := 10;
  Self.Label2.Text := 'Slection';
  // 
  // Label3
  // 
  Self.Label3.FlatStyle := System.Windows.Forms.FlatStyle.Flat;
  Self.Label3.Location := System.Drawing.Point.Create(1, 135);
  Self.Label3.Name := 'Label3';
  Self.Label3.Size := System.Drawing.Size.Create(100, 12);
  Self.Label3.TabIndex := 11;
  Self.Label3.Text := 'Rsultats';
  // 
  // TWinForm2
  // 
  Self.AutoScaleBaseSize := System.Drawing.Size.Create(5, 13);
  Self.ClientSize := System.Drawing.Size.Create(596, 407);
  Self.Controls.Add(Self.Label3);
  Self.Controls.Add(Self.Label2);
  Self.Controls.Add(Self.TextBox4);
  Self.Controls.Add(Self.RadioButton1);
  Self.Controls.Add(Self.txtmemo);
  Self.Controls.Add(Self.TextBox3);
  Self.Controls.Add(Self.TextBox2);
  Self.Controls.Add(Self.TextBox1);
  Self.Controls.Add(Self.Label1);
  Self.Controls.Add(Self.RadioButton3);
  Self.Controls.Add(Self.RadioButton2);
  Self.Controls.Add(Self.Button1);
  Self.Name := 'TWinForm2';
  Self.Text := 'Livre Delphi Studio - BDP - BdpCommand -  O.D.';
  Self.ResumeLayout(False);
end;
{$ENDREGION}

procedure TWinForm2.Dispose(Disposing: Boolean);
begin
  if Disposing then
  begin
    if Components <> nil then
      Components.Dispose();
  end;
  inherited Dispose(Disposing);
end;

constructor TWinForm2.Create;
begin
  inherited Create;
  //
  // Obligatoire pour la gestion du concepteur de Windows Form
  //
  InitializeComponent;
  //
  // TODO: Ajouter du code au constructeur aprs l'appel de InitializeComponent
  //
  txtmemo.Clear;
end;

procedure TWinForm2.Button1_Click(sender: System.Object; e: System.EventArgs);
var s:string; i:integer; duree:tdatetime;
    Reader:BdpDataReader;
begin
 i:=0;
 if radiobutton2.Checked then i:=1;
 if radiobutton3.Checked then i:=2;
 BdpCommand1.Parameters.Clear;
 case i of
 0 : begin
       BdpCommand1.CommandText:=TextBox1.Text;
       BdpCommand1.CommandType:=System.Data.CommandType.Text;
     end;
 1 : begin
       BdpCommand1.CommandText:=TextBox2.Text;
       BdpCommand1.CommandType:=System.Data.CommandType.Text;
       BdpCommand1.Parameters.Add('P_SIZE',Borland.Data.Common.BdpType.Int32);
       BdpCommand1.Parameters.Item['P_SIZE'].Value := Int32( StrToIntDef(TextBox4.Text,10) );
     end;
 2 : begin
      BdpCommand1.CommandText:=TextBox3.Text;
      BdpCommand1.CommandType:=System.Data.CommandType.Text;
     end;
 end;
txtmemo.Text:=txtmemo.text+'Excution de : '+BdpCommand1.CommandText+#13#10;
txtmemo.Text:=txtmemo.text+'Dbut : '+formatdatetime('hh:nn:ss:zzz',now)+
              #13#10+DupeString('-',70)+#13#10;
Reader:=nil;
try
  BdpConnection1.Open;
  try
    duree:=now;
    case i of
    0: Reader:=BdpCommand1.ExecuteReader();
    1: begin
         i:=BdpCommand1.ExecuteNonQuery;
         txtmemo.Text:=txtmemo.Text+#13#10+inttostr(i)+' enregistrement(s) modifi(s)'+#13#10;
       end;
    2: begin
        txtmemo.Text:=txtmemo.Text+#13#10+BdpCommand1.ExecuteScalar.ToString+#13#10;
       end;
    end;
    duree:=now-duree;
    if assigned(Reader) then
    try
      s:='';
      while Reader.Read do
       begin
        For i:=0 to Reader.FieldCount-1 do
         begin
          if s.Trim<>'' then s:=s+', ';
          s:=s + Reader.GetValue(i).ToString;
         end;
        txtmemo.text:=txtmemo.Text+#13#10+s;
        s:='';
        end;
     finally
      Reader.Close;
      BdpCommand1.Close;
     end;
   finally
    BdpConnection1.Close;
   end;
Except
 on e:exception do messagebox.Show(e.Message);
end;
txtmemo.Text:=txtmemo.Text+#13#10+DupeString('-',70)+#13#10;
txtmemo.Text:=txtmemo.text+'Fin : '+formatdatetime('hh:nn:ss:zzz',now)+
                           ' Dure : '+formatdatetime('hh:nn:ss:zzz',duree)+
              #13#10+DupeString('-',70)+#13#10;
txtmemo.Focus;
txtmemo.ScrollToCaret;
txtmemo.SelectionStart:=txtmemo.TextLength;
end;

end.
