{
    *******************************************************
    * "De Delphi  C# avec BDS 2006"  ISBN 2-212-11768-X  *
    *******************************************************
    *                                                     *
    * Code source correspond aux exemples traits dans l' *
    * ouvrage.                                            *
    *                                                     *
    * Environment : Borland Developer Studio 2006         *
    * Test sur la version Architecte Franaise patch 1   *
    *                                                     *
    * Copyright   : Olivier Dahan                         *
    *                                                     *
    * Aucune copie, distribution, publication sans l'     *
    * accord exprs de l'auteur.                          *
    * Le prsent code source est fourni "tel quel"       *
    * titre d'illustration des propos techniques du livre *
    * Aucune garantie de fonctionnement ou d'adaptation   *
    * n'est fournie, aucune maintenance corrective ou     *
    * volutive ne sera fournie sur le prsent code.      *
    * Vous utilisez ce code sous votre seule responsabi-  *
    * lit et  vos risques et prils. L'auteur ne serait *
    * tre tenu pour responsable d'ventuelles pertes de  *
    * donnes ou de jouissance qui pourraient rsulter de *
    * l'utilisation du prsent code.                      *
    *                                                     *
    * Contact          : BDSLivre@e-naxos.com             *
    * Site de l'auteur : http://www.e-naxos.com           *
    *******************************************************

}



unit MainForm;

interface

uses
  System.Drawing, System.Collections, System.ComponentModel,
  System.Windows.Forms, System.Data, Borland.Data.Provider, Borland.Data.Common, 
  System.Globalization, System.Resources;

type
  TWinForm2 = class(System.Windows.Forms.Form)
  {$REGION 'Code manag du concepteur'}
  strict private
    /// <summary>
    /// Variable concepteur obligatoire.
    /// </summary>
    Components: System.ComponentModel.Container;
    BdpConnection1: Borland.Data.Provider.BdpConnection;
    BdpCommand1: Borland.Data.Provider.BdpCommand;
    Button1: System.Windows.Forms.Button;
    BdpCommand2: Borland.Data.Provider.BdpCommand;
    bdpInsertCommand1: Borland.Data.Provider.BdpCommand;
    bdpUpdateCommand1: Borland.Data.Provider.BdpCommand;
    bdpDeleteCommand1: Borland.Data.Provider.BdpCommand;
    BdpDataAdapter1: Borland.Data.Provider.BdpDataAdapter;
    DataSet1: System.Data.DataSet;
    DataGrid1: System.Windows.Forms.DataGrid;
    DataGridTableStyle1: System.Windows.Forms.DataGridTableStyle;
    DataGridTextBoxColumn1: System.Windows.Forms.DataGridTextBoxColumn;
    DataGridTextBoxColumn2: System.Windows.Forms.DataGridTextBoxColumn;
    DataGridTextBoxColumn3: System.Windows.Forms.DataGridTextBoxColumn;
    Panel1: System.Windows.Forms.Panel;
    Label1: System.Windows.Forms.Label;
    Label2: System.Windows.Forms.Label;
    DataTable1: System.Data.DataTable;
    DataColumn1: System.Data.DataColumn;
    DataColumn2: System.Data.DataColumn;
    DataColumn3: System.Data.DataColumn;
    /// <summary>
    /// Mthode obligatoire pour la gestion du concepteur - Ne modifiez pas
    /// le contenu de cette mthode avec l'diteur de code.
    /// </summary>
    procedure InitializeComponent;
    procedure Button1_Click(sender: System.Object; e: System.EventArgs);
  {$ENDREGION}
  strict protected
    /// <summary>
    /// Nettoyage des ressources utilises.
    /// </summary>
    procedure Dispose(Disposing: Boolean); override;
  private
    { Dclarations prives }
  public
    constructor Create;
  end;

  [assembly: RuntimeRequiredAttribute(TypeOf(TWinForm2))]

implementation

{$AUTOBOX ON}

{$REGION 'Code gnr par le concepteur de Windows Form'}
/// <summary>
/// Mthode obligatoire pour la gestion du concepteur - Ne modifiez pas
/// le contenu de cette mthode avec l'diteur de code.
/// </summary>
procedure TWinForm2.InitializeComponent;
type
  TArrayOfSystem_Data_DataTable = array of System.Data.DataTable;
  TArrayOfSystem_Data_DataColumn = array of System.Data.DataColumn;
  TArrayOfSystem_Windows_Forms_DataGridTableStyle = array of System.Windows.Forms.DataGridTableStyle;
  TArrayOfSystem_Windows_Forms_DataGridColumnStyle = array of System.Windows.Forms.DataGridColumnStyle;
begin
  Self.BdpConnection1 := Borland.Data.Provider.BdpConnection.Create;
  Self.BdpCommand1 := Borland.Data.Provider.BdpCommand.Create;
  Self.BdpCommand2 := Borland.Data.Provider.BdpCommand.Create;
  Self.bdpInsertCommand1 := Borland.Data.Provider.BdpCommand.Create;
  Self.bdpUpdateCommand1 := Borland.Data.Provider.BdpCommand.Create;
  Self.bdpDeleteCommand1 := Borland.Data.Provider.BdpCommand.Create;
  Self.BdpDataAdapter1 := Borland.Data.Provider.BdpDataAdapter.Create;
  Self.DataSet1 := System.Data.DataSet.Create;
  Self.DataTable1 := System.Data.DataTable.Create;
  Self.DataColumn1 := System.Data.DataColumn.Create;
  Self.DataColumn2 := System.Data.DataColumn.Create;
  Self.DataColumn3 := System.Data.DataColumn.Create;
  Self.DataGrid1 := System.Windows.Forms.DataGrid.Create;
  Self.DataGridTableStyle1 := System.Windows.Forms.DataGridTableStyle.Create;
  Self.DataGridTextBoxColumn1 := System.Windows.Forms.DataGridTextBoxColumn.Create;
  Self.DataGridTextBoxColumn2 := System.Windows.Forms.DataGridTextBoxColumn.Create;
  Self.DataGridTextBoxColumn3 := System.Windows.Forms.DataGridTextBoxColumn.Create;
  Self.Panel1 := System.Windows.Forms.Panel.Create;
  Self.Button1 := System.Windows.Forms.Button.Create;
  Self.Label2 := System.Windows.Forms.Label.Create;
  Self.Label1 := System.Windows.Forms.Label.Create;
  (System.ComponentModel.ISupportInitialize(Self.BdpDataAdapter1)).BeginInit;
  (System.ComponentModel.ISupportInitialize(Self.DataSet1)).BeginInit;
  (System.ComponentModel.ISupportInitialize(Self.DataTable1)).BeginInit;
  (System.ComponentModel.ISupportInitialize(Self.DataGrid1)).BeginInit;
  Self.Panel1.SuspendLayout;
  Self.SuspendLayout;
  // 
  // BdpConnection1
  // 
  Self.BdpConnection1.ConnectionOptions := 'waitonlocks=False;commitretain=F' +
  'alse;sqldialect=3;transaction isolation=ReadCommitted;servercharset=;role' +
  'name=';
  Self.BdpConnection1.ConnectionString := 'assembly=Borland.Data.Interbase, ' +
  'Version=2.5.0.0, Culture=neutral, PublicKeyToken=91d62ebb5b0d1b1b;vendorc' +
  'lient=gds32.dll;pooling=True;grow on demand=True;database=..\data\intlemp' +
  '.gdb;username=sysdba;max pool size=100;password=masterkey;provider=Interb' +
  'ase';
  // 
  // BdpCommand1
  // 
  Self.BdpCommand1.CommandOptions := nil;
  Self.BdpCommand1.CommandText := 'Get_Emp_Proj_Count';
  Self.BdpCommand1.CommandType := System.Data.CommandType.StoredProcedure;
  Self.BdpCommand1.Connection := Self.BdpConnection1;
  Self.BdpCommand1.ParameterCount := (SmallInt(2));
  Self.BdpCommand1.Parameters.Add(Borland.Data.Common.BdpParameter.Create('E' +
      'MP_NO', Borland.Data.Common.BdpType.Int16, Borland.Data.Common.BdpType.Unknown, 
        0, System.Data.ParameterDirection.Input, False, (Byte(0)), (Byte(0)), 
        0, '', System.Data.DataRowVersion.Current, nil));
  Self.BdpCommand1.Parameters.Add(Borland.Data.Common.BdpParameter.Create('P' +
      '_COUNT', Borland.Data.Common.BdpType.Int32, Borland.Data.Common.BdpType.Unknown, 
        0, System.Data.ParameterDirection.Output, False, (Byte(0)), (Byte(0)), 
        0, '', System.Data.DataRowVersion.Current, nil));
  Self.BdpCommand1.SchemaName := nil;
  Self.BdpCommand1.Transaction := nil;
  Self.BdpCommand1.UpdatedRowSource := System.Data.UpdateRowSource.None;
  // 
  // BdpCommand2
  // 
  Self.BdpCommand2.CommandOptions := nil;
  Self.BdpCommand2.CommandText := 'SELECT EMP_NO, FIRST_NAME, LAST_NAME FROM' +
  ' EMPLOYEE E WHERE EXISTS (select * from employee_project EE where EE.EMP_' +
  'NO = E.EMP_NO)';
  Self.BdpCommand2.CommandType := System.Data.CommandType.Text;
  Self.BdpCommand2.Connection := Self.BdpConnection1;
  Self.BdpCommand2.ParameterCount := (SmallInt(0));
  Self.BdpCommand2.SchemaName := nil;
  Self.BdpCommand2.Transaction := nil;
  Self.BdpCommand2.UpdatedRowSource := System.Data.UpdateRowSource.None;
  // 
  // bdpInsertCommand1
  // 
  Self.bdpInsertCommand1.CommandOptions := nil;
  Self.bdpInsertCommand1.CommandText := nil;
  Self.bdpInsertCommand1.CommandType := System.Data.CommandType.Text;
  Self.bdpInsertCommand1.Connection := nil;
  Self.bdpInsertCommand1.ParameterCount := (SmallInt(0));
  Self.bdpInsertCommand1.SchemaName := nil;
  Self.bdpInsertCommand1.Transaction := nil;
  Self.bdpInsertCommand1.UpdatedRowSource := System.Data.UpdateRowSource.None;
  // 
  // bdpUpdateCommand1
  // 
  Self.bdpUpdateCommand1.CommandOptions := nil;
  Self.bdpUpdateCommand1.CommandText := nil;
  Self.bdpUpdateCommand1.CommandType := System.Data.CommandType.Text;
  Self.bdpUpdateCommand1.Connection := nil;
  Self.bdpUpdateCommand1.ParameterCount := (SmallInt(0));
  Self.bdpUpdateCommand1.SchemaName := nil;
  Self.bdpUpdateCommand1.Transaction := nil;
  Self.bdpUpdateCommand1.UpdatedRowSource := System.Data.UpdateRowSource.None;
  // 
  // bdpDeleteCommand1
  // 
  Self.bdpDeleteCommand1.CommandOptions := nil;
  Self.bdpDeleteCommand1.CommandText := nil;
  Self.bdpDeleteCommand1.CommandType := System.Data.CommandType.Text;
  Self.bdpDeleteCommand1.Connection := nil;
  Self.bdpDeleteCommand1.ParameterCount := (SmallInt(0));
  Self.bdpDeleteCommand1.SchemaName := nil;
  Self.bdpDeleteCommand1.Transaction := nil;
  Self.bdpDeleteCommand1.UpdatedRowSource := System.Data.UpdateRowSource.None;
  // 
  // BdpDataAdapter1
  // 
  Self.BdpDataAdapter1.Active := False;
  Self.BdpDataAdapter1.DataSet := Self.DataSet1;
  Self.BdpDataAdapter1.DataTable := Self.DataTable1;
  Self.BdpDataAdapter1.DeleteCommand := Self.bdpDeleteCommand1;
  Self.BdpDataAdapter1.InsertCommand := Self.bdpInsertCommand1;
  Self.BdpDataAdapter1.SelectCommand := Self.BdpCommand2;
  Self.BdpDataAdapter1.StartRecord := 0;
  Self.BdpDataAdapter1.UpdateCommand := Self.bdpUpdateCommand1;
  // 
  // DataSet1
  // 
  Self.DataSet1.DataSetName := 'NewDataSet';
  Self.DataSet1.Locale := System.Globalization.CultureInfo.Create('fr-FR');
  Self.DataSet1.Tables.AddRange(TArrayOfSystem_Data_DataTable.Create(Self.DataTable1));
  // 
  // DataTable1
  // 
  Self.DataTable1.Columns.AddRange(TArrayOfSystem_Data_DataColumn.Create(Self.DataColumn1, 
          Self.DataColumn2, Self.DataColumn3));
  Self.DataTable1.TableName := 'EMPLOYEE';
  // 
  // DataColumn1
  // 
  Self.DataColumn1.ColumnName := 'EMP_NO';
  Self.DataColumn1.DataType := TypeOf(SmallInt);
  // 
  // DataColumn2
  // 
  Self.DataColumn2.ColumnName := 'FIRST_NAME';
  // 
  // DataColumn3
  // 
  Self.DataColumn3.ColumnName := 'LAST_NAME';
  // 
  // DataGrid1
  // 
  Self.DataGrid1.AlternatingBackColor := System.Drawing.Color.Gainsboro;
  Self.DataGrid1.BackColor := System.Drawing.Color.Silver;
  Self.DataGrid1.BackgroundColor := System.Drawing.Color.Silver;
  Self.DataGrid1.BorderStyle := System.Windows.Forms.BorderStyle.FixedSingle;
  Self.DataGrid1.CaptionBackColor := System.Drawing.Color.DarkSlateBlue;
  Self.DataGrid1.CaptionFont := System.Drawing.Font.Create('Microsoft Sans S' +
    'erif', 8, System.Drawing.FontStyle.Bold);
  Self.DataGrid1.CaptionForeColor := System.Drawing.Color.White;
  Self.DataGrid1.CaptionText := 'Liste des employs';
  Self.DataGrid1.DataMember := '';
  Self.DataGrid1.DataSource := Self.DataSet1;
  Self.DataGrid1.Dock := System.Windows.Forms.DockStyle.Left;
  Self.DataGrid1.FlatMode := True;
  Self.DataGrid1.ForeColor := System.Drawing.Color.Black;
  Self.DataGrid1.GridLineColor := System.Drawing.Color.White;
  Self.DataGrid1.HeaderBackColor := System.Drawing.Color.DarkGray;
  Self.DataGrid1.HeaderForeColor := System.Drawing.Color.Black;
  Self.DataGrid1.LinkColor := System.Drawing.Color.DarkSlateBlue;
  Self.DataGrid1.Location := System.Drawing.Point.Create(0, 0);
  Self.DataGrid1.Name := 'DataGrid1';
  Self.DataGrid1.ParentRowsBackColor := System.Drawing.Color.Black;
  Self.DataGrid1.ParentRowsForeColor := System.Drawing.Color.White;
  Self.DataGrid1.ReadOnly := True;
  Self.DataGrid1.SelectionBackColor := System.Drawing.Color.DarkSlateBlue;
  Self.DataGrid1.SelectionForeColor := System.Drawing.Color.White;
  Self.DataGrid1.Size := System.Drawing.Size.Create(315, 206);
  Self.DataGrid1.TabIndex := 1;
  Self.DataGrid1.TableStyles.AddRange(TArrayOfSystem_Windows_Forms_DataGridTableStyle.Create(Self.DataGridTableStyle1));
  // 
  // DataGridTableStyle1
  // 
  Self.DataGridTableStyle1.AlternatingBackColor := System.Drawing.Color.Gainsboro;
  Self.DataGridTableStyle1.BackColor := System.Drawing.Color.Silver;
  Self.DataGridTableStyle1.DataGrid := Self.DataGrid1;
  Self.DataGridTableStyle1.ForeColor := System.Drawing.Color.Black;
  Self.DataGridTableStyle1.GridColumnStyles.AddRange(TArrayOfSystem_Windows_Forms_DataGridColumnStyle.Create(Self.DataGridTextBoxColumn1, 
          Self.DataGridTextBoxColumn2, Self.DataGridTextBoxColumn3));
  Self.DataGridTableStyle1.GridLineColor := System.Drawing.Color.White;
  Self.DataGridTableStyle1.HeaderBackColor := System.Drawing.Color.DarkGray;
  Self.DataGridTableStyle1.HeaderFont := System.Drawing.Font.Create('Microso' +
    'ft Sans Serif', 8.25, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, 
      (Byte(0)));
  Self.DataGridTableStyle1.HeaderForeColor := System.Drawing.Color.Black;
  Self.DataGridTableStyle1.LinkColor := System.Drawing.Color.DarkSlateBlue;
  Self.DataGridTableStyle1.MappingName := 'EMPLOYEE';
  Self.DataGridTableStyle1.SelectionBackColor := System.Drawing.Color.DarkSlateBlue;
  Self.DataGridTableStyle1.SelectionForeColor := System.Drawing.Color.White;
  // 
  // DataGridTextBoxColumn1
  // 
  Self.DataGridTextBoxColumn1.Alignment := System.Windows.Forms.HorizontalAlignment.Center;
  Self.DataGridTextBoxColumn1.Format := '###';
  Self.DataGridTextBoxColumn1.FormatInfo := nil;
  Self.DataGridTextBoxColumn1.HeaderText := 'Num';
  Self.DataGridTextBoxColumn1.MappingName := 'EMP_NO';
  Self.DataGridTextBoxColumn1.ReadOnly := True;
  Self.DataGridTextBoxColumn1.Width := 40;
  // 
  // DataGridTextBoxColumn2
  // 
  Self.DataGridTextBoxColumn2.Format := '';
  Self.DataGridTextBoxColumn2.FormatInfo := nil;
  Self.DataGridTextBoxColumn2.HeaderText := 'Prnom';
  Self.DataGridTextBoxColumn2.MappingName := 'FIRST_NAME';
  Self.DataGridTextBoxColumn2.Width := 110;
  // 
  // DataGridTextBoxColumn3
  // 
  Self.DataGridTextBoxColumn3.Format := '';
  Self.DataGridTextBoxColumn3.FormatInfo := nil;
  Self.DataGridTextBoxColumn3.HeaderText := 'Nom';
  Self.DataGridTextBoxColumn3.MappingName := 'LAST_NAME';
  Self.DataGridTextBoxColumn3.Width := 110;
  // 
  // Panel1
  // 
  Self.Panel1.Controls.Add(Self.Button1);
  Self.Panel1.Controls.Add(Self.Label2);
  Self.Panel1.Controls.Add(Self.Label1);
  Self.Panel1.Dock := System.Windows.Forms.DockStyle.Fill;
  Self.Panel1.Location := System.Drawing.Point.Create(315, 0);
  Self.Panel1.Name := 'Panel1';
  Self.Panel1.Size := System.Drawing.Size.Create(140, 206);
  Self.Panel1.TabIndex := 2;
  // 
  // Button1
  // 
  Self.Button1.BackColor := System.Drawing.Color.FromArgb((Byte(255)), (Byte(192)), 
      (Byte(255)));
  Self.Button1.FlatStyle := System.Windows.Forms.FlatStyle.Flat;
  Self.Button1.Location := System.Drawing.Point.Create(33, 166);
  Self.Button1.Name := 'Button1';
  Self.Button1.TabIndex := 2;
  Self.Button1.Text := 'Calculer!';
  Include(Self.Button1.Click, Self.Button1_Click);
  // 
  // Label2
  // 
  Self.Label2.BackColor := System.Drawing.Color.Transparent;
  Self.Label2.Dock := System.Windows.Forms.DockStyle.Fill;
  Self.Label2.FlatStyle := System.Windows.Forms.FlatStyle.Flat;
  Self.Label2.Font := System.Drawing.Font.Create('Verdana', 8.25, System.Drawing.FontStyle.Bold, 
      System.Drawing.GraphicsUnit.Point, (Byte(0)));
  Self.Label2.ForeColor := System.Drawing.Color.Black;
  Self.Label2.Location := System.Drawing.Point.Create(0, 23);
  Self.Label2.Name := 'Label2';
  Self.Label2.Size := System.Drawing.Size.Create(140, 183);
  Self.Label2.TabIndex := 1;
  Self.Label2.Text := '? projets';
  Self.Label2.TextAlign := System.Drawing.ContentAlignment.MiddleCenter;
  // 
  // Label1
  // 
  Self.Label1.BackColor := System.Drawing.Color.Transparent;
  Self.Label1.Dock := System.Windows.Forms.DockStyle.Top;
  Self.Label1.Font := System.Drawing.Font.Create('Verdana', 8.25, System.Drawing.FontStyle.Bold, 
      System.Drawing.GraphicsUnit.Point, (Byte(0)));
  Self.Label1.Location := System.Drawing.Point.Create(0, 0);
  Self.Label1.Name := 'Label1';
  Self.Label1.Size := System.Drawing.Size.Create(140, 23);
  Self.Label1.TabIndex := 0;
  Self.Label1.Text := 'Nb Projets affects';
  Self.Label1.TextAlign := System.Drawing.ContentAlignment.MiddleCenter;
  // 
  // TWinForm2
  // 
  Self.AutoScaleBaseSize := System.Drawing.Size.Create(6, 14);
  Self.ClientSize := System.Drawing.Size.Create(455, 206);
  Self.Controls.Add(Self.Panel1);
  Self.Controls.Add(Self.DataGrid1);
  Self.Font := System.Drawing.Font.Create('Verdana', 8.25, System.Drawing.FontStyle.Regular, 
      System.Drawing.GraphicsUnit.Point, (Byte(0)));
  Self.Name := 'TWinForm2';
  Self.Text := 'Livre Delphi.NET - BDP - StoredProc -  O.D.';
  (System.ComponentModel.ISupportInitialize(Self.BdpDataAdapter1)).EndInit;
  (System.ComponentModel.ISupportInitialize(Self.DataSet1)).EndInit;
  (System.ComponentModel.ISupportInitialize(Self.DataTable1)).EndInit;
  (System.ComponentModel.ISupportInitialize(Self.DataGrid1)).EndInit;
  Self.Panel1.ResumeLayout(False);
  Self.ResumeLayout(False);
end;
{$ENDREGION}

procedure TWinForm2.Dispose(Disposing: Boolean);
begin
  if Disposing then
  begin
    if Components <> nil then
      Components.Dispose();
  end;
  inherited Dispose(Disposing);
end;

constructor TWinForm2.Create;
begin
  inherited Create;
  //
  // Obligatoire pour la gestion du concepteur de Windows Form
  //
  InitializeComponent;
  //
  // TODO: Ajouter du code au constructeur aprs l'appel de InitializeComponent
  //
  BdpConnection1.Open;
  BdpDataAdapter1.Active:=true;
  DataGrid1.DataMember:='EMPLOYEE';
end;




procedure TWinForm2.Button1_Click(sender: System.Object; e: System.EventArgs);
begin
  bdpcommand1.Parameters.Item['EMP_NO'].Value :=
    DataGrid1.Item[DataGrid1.CurrentRowIndex,0];
  bdpcommand1.ExecuteScalar;
  Label2.text :=bdpcommand1.Parameters.Item['P_COUNT'].Value.ToString+
                ' Projets';
end;

end.
