{
    *******************************************************
    * "De Delphi  C# avec BDS 2006"  ISBN 2-212-11768-X  *
    *******************************************************
    *                                                     *
    * Code source correspond aux exemples traits dans l' *
    * ouvrage.                                            *
    *                                                     *
    * Environment : Borland Developer Studio 2006         *
    * Test sur la version Architecte Franaise patch 1   *
    *                                                     *
    * Copyright   : Olivier Dahan                         *
    *                                                     *
    * Aucune copie, distribution, publication sans l'     *
    * accord exprs de l'auteur.                          *
    * Le prsent code source est fourni "tel quel"       *
    * titre d'illustration des propos techniques du livre *
    * Aucune garantie de fonctionnement ou d'adaptation   *
    * n'est fournie, aucune maintenance corrective ou     *
    * volutive ne sera fournie sur le prsent code.      *
    * Vous utilisez ce code sous votre seule responsabi-  *
    * lit et  vos risques et prils. L'auteur ne serait *
    * tre tenu pour responsable d'ventuelles pertes de  *
    * donnes ou de jouissance qui pourraient rsulter de *
    * l'utilisation du prsent code.                      *
    *                                                     *
    * Contact          : BDSLivre@e-naxos.com             *
    * Site de l'auteur : http://www.e-naxos.com           *
    *******************************************************

}



unit MainForm;

interface

uses
  System.Drawing, System.Collections, System.ComponentModel,
  System.Windows.Forms, System.Data, Borland.Data.Provider,
  Borland.Data.Schema;

type
  TMainForm = class(System.Windows.Forms.Form)
  {$REGION 'Code manag du concepteur'}
  strict private
    /// <summary>
    /// Variable concepteur obligatoire.
    /// </summary>
    Components: System.ComponentModel.Container;
    BdpConnection1: Borland.Data.Provider.BdpConnection;
    DataGrid1: System.Windows.Forms.DataGrid;
    btnTables: System.Windows.Forms.Button;
    cbTables: System.Windows.Forms.ComboBox;
    btnColonnes: System.Windows.Forms.Button;
    StatusBar1: System.Windows.Forms.StatusBar;
    btnIndex: System.Windows.Forms.Button;
    gbIndices: System.Windows.Forms.GroupBox;
    rbunique: System.Windows.Forms.RadioButton;
    rbnonunique: System.Windows.Forms.RadioButton;
    rbPrimary: System.Windows.Forms.RadioButton;
    /// <summary>
    /// Mthode obligatoire pour la gestion du concepteur - Ne modifiez pas
    /// le contenu de cette mthode avec l'diteur de code.
    /// </summary>
    procedure InitializeComponent;
    procedure btnTables_Click(sender: System.Object; e: System.EventArgs);
    procedure btnColonnes_Click(sender: System.Object; e: System.EventArgs);
    procedure btnIndex_Click(sender: System.Object; e: System.EventArgs);
  {$ENDREGION}
  strict protected
    /// <summary>
    /// Nettoyage des ressources utilises.
    /// </summary>
    procedure Dispose(Disposing: Boolean); override;
  private
    { Dclarations prives }
  public
    constructor Create;
  end;

  [assembly: RuntimeRequiredAttribute(TypeOf(TMainForm))]

implementation

{$AUTOBOX ON}

{$REGION 'Code gnr par le concepteur de Windows Form'}
/// <summary>
/// Mthode obligatoire pour la gestion du concepteur - Ne modifiez pas
/// le contenu de cette mthode avec l'diteur de code.
/// </summary>
procedure TMainForm.InitializeComponent;
begin
  Self.BdpConnection1 := Borland.Data.Provider.BdpConnection.Create;
  Self.DataGrid1 := System.Windows.Forms.DataGrid.Create;
  Self.btnTables := System.Windows.Forms.Button.Create;
  Self.cbTables := System.Windows.Forms.ComboBox.Create;
  Self.btnColonnes := System.Windows.Forms.Button.Create;
  Self.StatusBar1 := System.Windows.Forms.StatusBar.Create;
  Self.btnIndex := System.Windows.Forms.Button.Create;
  Self.gbIndices := System.Windows.Forms.GroupBox.Create;
  Self.rbPrimary := System.Windows.Forms.RadioButton.Create;
  Self.rbnonunique := System.Windows.Forms.RadioButton.Create;
  Self.rbunique := System.Windows.Forms.RadioButton.Create;
  (System.ComponentModel.ISupportInitialize(Self.DataGrid1)).BeginInit;
  Self.gbIndices.SuspendLayout;
  Self.SuspendLayout;
  // 
  // BdpConnection1
  // 
  Self.BdpConnection1.ConnectionOptions := 'waitonlocks=False;commitretain=F' +
  'alse;sqldialect=3;transaction isolation=ReadCommitted;servercharset=;role' +
  'name=';
  Self.BdpConnection1.ConnectionString := 'assembly=Borland.Data.Interbase, ' +
  'Version=2.5.0.0, Culture=neutral, PublicKeyToken=91d62ebb5b0d1b1b;vendorc' +
  'lient=gds32.dll;pooling=True;grow on demand=True;database=..\Data\dbdemos' +
  '.gdb;username=sysdba;max pool size=100;password=masterkey;provider=Interb' +
  'ase';
  // 
  // DataGrid1
  // 
  Self.DataGrid1.AlternatingBackColor := System.Drawing.Color.Lavender;
  Self.DataGrid1.BackColor := System.Drawing.Color.WhiteSmoke;
  Self.DataGrid1.BackgroundColor := System.Drawing.Color.LightGray;
  Self.DataGrid1.BorderStyle := System.Windows.Forms.BorderStyle.None;
  Self.DataGrid1.CaptionBackColor := System.Drawing.Color.LightSteelBlue;
  Self.DataGrid1.CaptionFont := System.Drawing.Font.Create('Microsoft Sans S' +
    'erif', 8);
  Self.DataGrid1.CaptionForeColor := System.Drawing.Color.MidnightBlue;
  Self.DataGrid1.DataMember := '';
  Self.DataGrid1.Dock := System.Windows.Forms.DockStyle.Bottom;
  Self.DataGrid1.FlatMode := True;
  Self.DataGrid1.Font := System.Drawing.Font.Create('Microsoft Sans Serif', 8);
  Self.DataGrid1.ForeColor := System.Drawing.Color.MidnightBlue;
  Self.DataGrid1.GridLineColor := System.Drawing.Color.Gainsboro;
  Self.DataGrid1.GridLineStyle := System.Windows.Forms.DataGridLineStyle.None;
  Self.DataGrid1.HeaderBackColor := System.Drawing.Color.MidnightBlue;
  Self.DataGrid1.HeaderFont := System.Drawing.Font.Create('Microsoft Sans Se' +
    'rif', 8);
  Self.DataGrid1.HeaderForeColor := System.Drawing.Color.WhiteSmoke;
  Self.DataGrid1.LinkColor := System.Drawing.Color.Teal;
  Self.DataGrid1.Location := System.Drawing.Point.Create(0, 65);
  Self.DataGrid1.Name := 'DataGrid1';
  Self.DataGrid1.ParentRowsBackColor := System.Drawing.Color.Gainsboro;
  Self.DataGrid1.ParentRowsForeColor := System.Drawing.Color.MidnightBlue;
  Self.DataGrid1.SelectionBackColor := System.Drawing.Color.CadetBlue;
  Self.DataGrid1.SelectionForeColor := System.Drawing.Color.WhiteSmoke;
  Self.DataGrid1.Size := System.Drawing.Size.Create(674, 292);
  Self.DataGrid1.TabIndex := 0;
  // 
  // btnTables
  // 
  Self.btnTables.Location := System.Drawing.Point.Create(11, 9);
  Self.btnTables.Name := 'btnTables';
  Self.btnTables.TabIndex := 1;
  Self.btnTables.Text := 'Tables';
  Include(Self.btnTables.Click, Self.btnTables_Click);
  // 
  // cbTables
  // 
  Self.cbTables.DropDownStyle := System.Windows.Forms.ComboBoxStyle.DropDownList;
  Self.cbTables.Location := System.Drawing.Point.Create(96, 10);
  Self.cbTables.Name := 'cbTables';
  Self.cbTables.Size := System.Drawing.Size.Create(180, 21);
  Self.cbTables.Sorted := True;
  Self.cbTables.TabIndex := 2;
  Self.cbTables.Visible := False;
  // 
  // btnColonnes
  // 
  Self.btnColonnes.Location := System.Drawing.Point.Create(96, 37);
  Self.btnColonnes.Name := 'btnColonnes';
  Self.btnColonnes.TabIndex := 3;
  Self.btnColonnes.Text := 'Colonnes';
  Include(Self.btnColonnes.Click, Self.btnColonnes_Click);
  // 
  // StatusBar1
  // 
  Self.StatusBar1.Location := System.Drawing.Point.Create(0, 357);
  Self.StatusBar1.Name := 'StatusBar1';
  Self.StatusBar1.Size := System.Drawing.Size.Create(674, 22);
  Self.StatusBar1.TabIndex := 4;
  // 
  // btnIndex
  // 
  Self.btnIndex.Location := System.Drawing.Point.Create(201, 37);
  Self.btnIndex.Name := 'btnIndex';
  Self.btnIndex.TabIndex := 5;
  Self.btnIndex.Text := 'Index';
  Include(Self.btnIndex.Click, Self.btnIndex_Click);
  // 
  // gbIndices
  // 
  Self.gbIndices.Controls.Add(Self.rbPrimary);
  Self.gbIndices.Controls.Add(Self.rbnonunique);
  Self.gbIndices.Controls.Add(Self.rbunique);
  Self.gbIndices.Location := System.Drawing.Point.Create(296, 11);
  Self.gbIndices.Name := 'gbIndices';
  Self.gbIndices.Size := System.Drawing.Size.Create(233, 49);
  Self.gbIndices.TabIndex := 6;
  Self.gbIndices.TabStop := False;
  Self.gbIndices.Text := 'Type d''index  afficher';
  // 
  // rbPrimary
  // 
  Self.rbPrimary.FlatStyle := System.Windows.Forms.FlatStyle.Flat;
  Self.rbPrimary.Location := System.Drawing.Point.Create(163, 20);
  Self.rbPrimary.Name := 'rbPrimary';
  Self.rbPrimary.Size := System.Drawing.Size.Create(66, 24);
  Self.rbPrimary.TabIndex := 2;
  Self.rbPrimary.Tag := '2';
  Self.rbPrimary.Text := 'Primaire';
  // 
  // rbnonunique
  // 
  Self.rbnonunique.Checked := True;
  Self.rbnonunique.FlatStyle := System.Windows.Forms.FlatStyle.Flat;
  Self.rbnonunique.Location := System.Drawing.Point.Create(73, 20);
  Self.rbnonunique.Name := 'rbnonunique';
  Self.rbnonunique.TabIndex := 1;
  Self.rbnonunique.TabStop := True;
  Self.rbnonunique.Tag := '1';
  Self.rbnonunique.Text := 'Non uniques';
  // 
  // rbunique
  // 
  Self.rbunique.FlatStyle := System.Windows.Forms.FlatStyle.Flat;
  Self.rbunique.Location := System.Drawing.Point.Create(7, 20);
  Self.rbunique.Name := 'rbunique';
  Self.rbunique.Size := System.Drawing.Size.Create(71, 24);
  Self.rbunique.TabIndex := 0;
  Self.rbunique.Tag := '0';
  Self.rbunique.Text := 'Uniques';
  // 
  // TMainForm
  // 
  Self.AutoScaleBaseSize := System.Drawing.Size.Create(5, 13);
  Self.ClientSize := System.Drawing.Size.Create(674, 379);
  Self.Controls.Add(Self.gbIndices);
  Self.Controls.Add(Self.btnIndex);
  Self.Controls.Add(Self.btnColonnes);
  Self.Controls.Add(Self.cbTables);
  Self.Controls.Add(Self.btnTables);
  Self.Controls.Add(Self.DataGrid1);
  Self.Controls.Add(Self.StatusBar1);
  Self.Name := 'TMainForm';
  Self.Text := 'DBP - Mtadonnes -   OD';
  (System.ComponentModel.ISupportInitialize(Self.DataGrid1)).EndInit;
  Self.gbIndices.ResumeLayout(False);
  Self.ResumeLayout(False);
end;
{$ENDREGION}

procedure TMainForm.Dispose(Disposing: Boolean);
begin
  if Disposing then
  begin
    if Components <> nil then
      Components.Dispose();
  end;
  inherited Dispose(Disposing);
end;

constructor TMainForm.Create;
begin
  inherited Create;
  //
  // Obligatoire pour la gestion du concepteur de Windows Form
  //
  InitializeComponent;
  //
  // TODO: Ajouter du code au constructeur aprs l'appel de InitializeComponent
  //
end;


procedure TMainForm.btnIndex_Click(sender: System.Object; e: System.EventArgs);
var D:DataTable; It : Borland.Data.Schema.IndexType;
begin
  if cbTables.Text.Trim='' then begin
   MessageBox.show('Slectionnez une table dans la combobox svp.');
   exit;
   end;
try
 if rbunique.Checked then It:=Borland.Data.Schema.IndexType.Unique else
  if rbnonunique.Checked then It:=Borland.Data.Schema.IndexType.NonUnique else
   It:=Borland.Data.Schema.IndexType.PrimaryKey;
 Datagrid1.DataSource:=nil;
 BdpConnection1.Open;
 try
  DataGrid1.CaptionText := 'Liste des Index de la table '+cbTables.Text.Trim;
  D:=BdpConnection1.GetMetaData.GetIndices(cbTables.Text.Trim,It);
  DataGrid1.DataSource := D;
 finally
  BdpConnection1.Close;
 end;
except
 on e:exception do
 DataGrid1.CaptionText:=e.Message;
end;
end;

procedure TMainForm.btnColonnes_Click(sender: System.Object; e: System.EventArgs);
var D:DataTable;
begin
  if cbTables.Text.Trim='' then begin
   MessageBox.show('Slectionnez une table dans la combobox svp.');
   exit;
   end;
try
 Datagrid1.DataSource:=nil;
 BdpConnection1.Open;
 try
  DataGrid1.CaptionText := 'Liste des Colonnes de la table '+cbTables.Text.Trim;
  D:=BdpConnection1.GetMetaData.GetColumns(cbTables.Text.Trim,'',Borland.Data.Schema.ColumnType.Unknown);
  DataGrid1.DataSource := D;
 finally
  BdpConnection1.Close;
 end;
except
 on e:exception do
 DataGrid1.CaptionText:=e.Message;
end;
end;

procedure TMainForm.btnTables_Click(sender: System.Object; e: System.EventArgs);
var D:DataTable; row : DataRow;
begin
try
 Datagrid1.DataSource:=nil;
 BdpConnection1.Open;
 try
  DataGrid1.CaptionText := 'Liste des tables';
  D:=BdpConnection1.GetMetaData.GetTables('',Borland.Data.Schema.TableType.Table);
  DataGrid1.DataSource := D;
  cbTables.Items.Clear;

  for row in D.Rows do
   cbTables.Items.Add(Row.Item['TableName']);

  cbTables.Visible:=true;


 finally
  BdpConnection1.Close;
 end;
except
 on e:exception do
 DataGrid1.CaptionText:=e.Message;
end;
end;

end.
